variables:
  APP_RELEASE: post-service
  IMG_K8S: alpine/k8s:1.20.15

stages:
  - deploy
  - release
  - production

.deploy:
  stage: deploy
  image: $IMG_K8S
  script:
    - kubectl config use-context skillbox4643622/microservices/deploy-configs:local-k8s
    - helm upgrade --set secret.dockerRegistry=$CI_DOCKER_REGISTRY -f values-$ENV.yaml --wait --debug --install --force $APP_RELEASE-$ENV .
  environment:
    name: $ENV
  tags:
    - docker

deploy-feature-script:
  extends: .deploy
  variables:
    ENV: feature
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /^feature/

deploy-dev-script:
  extends: .deploy
  variables:
    ENV: dev
  only:
    - master

deploy-release-script:
  extends: .deploy
  variables:
    ENV: preprod
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /^release/

create-release-script:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  release:
    tag_name: $CI_COMMIT_TAG
    description: "$CI_COMMIT_MESSAGE"
  only:
    - tags
  script:
    - echo "Creating release"
  tags:
    - docker

deploy-to-production:
  stage: production
  extends: .deploy
  variables:
    ENV: prod
  rules:
    - if: $CI_COMMIT_REF_NAME =~ /^release/
  when: manual
  tags:
    - docker

rollback:
  stage: production
  image: $IMG_K8S
  variables:
    ENV: prod
  interruptible: true
  needs:
    - deploy-to-production
  only:
    variables:
      - $CI_COMMIT_REF_NAME =~ /^release/
  when: manual
  environment:
    name: $ENV
  script:
    - kubectl config use-context skillbox4643622/microservices/deploy-configs:local-k8s
    - helm rollback $APP_RELEASE-$ENV